import { isNumber as j, isString as Pt, getPrefixCls as pe, isObject as gr } from "@gx-design-vue/pro-utils";
import { provide as tt, inject as rt, shallowRef as Se, defineComponent as se, watch as q, unref as vr, watchEffect as Rt, onBeforeUnmount as Nt, ref as $, computed as k, isRef as Bt, reactive as ft, createVNode as I, Transition as pr, withDirectives as mr, vShow as br, Fragment as yr, nextTick as dt, onMounted as Sr } from "vue";
import { useEventListener as xe, isClient as xr, useResizeObserver as ht } from "@vueuse/core";
const wr = {
  /**
   * @description height of scrollbar
   */
  height: {
    type: [String, Number],
    default: ""
  },
  /**
   * @description max height of scrollbar
   */
  maxHeight: {
    type: [String, Number],
    default: ""
  },
  /**
   * @description whether to use the native scrollbar
   */
  native: {
    type: Boolean,
    default: !1
  },
  /**
   * @description style of wrap
   */
  wrapStyle: {
    type: [Object, String],
    default: ""
  },
  /**
   * @description class of wrap
   */
  wrapClass: {
    type: [String, Array],
    default: ""
  },
  /**
   * @description class of view
   */
  viewClass: {
    type: [String, Array],
    default: ""
  },
  /**
   * @description style of view
   */
  viewStyle: {
    type: [Object, String],
    default: ""
  },
  /**
   * @description do not respond to container size changes, if the container size does not change, it is better to set it to optimize performance
   */
  noresize: Boolean,
  /**
   * @description element tag of the view
   */
  tag: {
    type: String,
    default: "div"
  },
  /**
   * @description always show
   */
  always: Boolean,
  /**
   * @description minimum size of scrollbar
   */
  minSize: {
    type: Number,
    default: 20
  }
}, Cr = {
  scroll: ({ scrollTop: e, scrollLeft: t }) => j(e) && j(t)
}, Dt = Symbol("scrollbarContextKey"), Tr = (e = Symbol(), t) => rt(e, t || {}), Mr = (e) => {
  tt(Dt, e);
}, Ar = () => Tr(Dt, {}), kr = {
  always: {
    type: Boolean,
    default: !0
  },
  width: String,
  height: String,
  ratioX: {
    type: Number,
    default: 1
  },
  ratioY: {
    type: Number,
    default: 1
  }
}, Hr = {
  vertical: Boolean,
  size: String,
  move: Number,
  ratio: {
    type: Number,
    required: !0
  },
  always: Boolean
}, Er = {
  vertical: {
    offset: "offsetHeight",
    scroll: "scrollTop",
    scrollSize: "scrollHeight",
    size: "height",
    key: "vertical",
    axis: "Y",
    client: "clientY",
    direction: "top"
  },
  horizontal: {
    offset: "offsetWidth",
    scroll: "scrollLeft",
    scrollSize: "scrollWidth",
    size: "width",
    key: "horizontal",
    axis: "X",
    client: "clientX",
    direction: "left"
  }
}, zr = (e) => Pt(e) ? !Number.isNaN(Number(e)) : !1, $r = ({ move: e, size: t, bar: r }) => ({
  [r.size]: t,
  transform: `translate${r.axis}(${e}%)`
});
function gt(e, t = "px") {
  if (!e)
    return "";
  if (j(e) || zr(e))
    return `${e}${t}`;
  if (Pt(e))
    return e;
  console.warn("utils/dom/style", "value 必须为数字");
}
function v() {
  return v = Object.assign ? Object.assign.bind() : function(e) {
    for (var t = 1; t < arguments.length; t++) {
      var r = arguments[t];
      for (var n in r)
        Object.prototype.hasOwnProperty.call(r, n) && (e[n] = r[n]);
    }
    return e;
  }, v.apply(this, arguments);
}
const Pr = (e, t) => {
  const r = v({}, e);
  return Object.keys(t).forEach((n) => {
    const o = r[n];
    if (o)
      o.type || o.default ? o.default = t[n] : o.def ? o.def(t[n]) : r[n] = {
        type: o,
        default: t[n]
      };
    else
      throw new Error(`not have ${n} prop`);
  }), r;
}, Rr = Pr, Nr = (e) => {
  const t = e;
  return t.install = function(r) {
    r.component(t.displayName || t.name, e);
  }, e;
};
function It(e) {
  return {
    type: Object,
    default: e
  };
}
function Ee(e) {
  return {
    type: Boolean,
    default: e
  };
}
function Br(e, t) {
  const r = {
    validator: () => !0,
    default: e
  };
  return r;
}
function vt(e) {
  return {
    type: Array,
    default: e
  };
}
function pt(e) {
  return {
    type: String,
    default: e
  };
}
function Dr(e, t) {
  return e ? {
    type: e,
    default: t
  } : Br(t);
}
function nt(e) {
  for (var t = 0, r, n = 0, o = e.length; o >= 4; ++n, o -= 4)
    r = e.charCodeAt(n) & 255 | (e.charCodeAt(++n) & 255) << 8 | (e.charCodeAt(++n) & 255) << 16 | (e.charCodeAt(++n) & 255) << 24, r = /* Math.imul(k, m): */
    (r & 65535) * 1540483477 + ((r >>> 16) * 59797 << 16), r ^= /* k >>> r: */
    r >>> 24, t = /* Math.imul(k, m): */
    (r & 65535) * 1540483477 + ((r >>> 16) * 59797 << 16) ^ /* Math.imul(h, m): */
    (t & 65535) * 1540483477 + ((t >>> 16) * 59797 << 16);
  switch (o) {
    case 3:
      t ^= (e.charCodeAt(n + 2) & 255) << 16;
    case 2:
      t ^= (e.charCodeAt(n + 1) & 255) << 8;
    case 1:
      t ^= e.charCodeAt(n) & 255, t = /* Math.imul(h, m): */
      (t & 65535) * 1540483477 + ((t >>> 16) * 59797 << 16);
  }
  return t ^= t >>> 13, t = /* Math.imul(h, m): */
  (t & 65535) * 1540483477 + ((t >>> 16) * 59797 << 16), ((t ^ t >>> 15) >>> 0).toString(36);
}
class Ir {
  constructor() {
    this.cache = /* @__PURE__ */ new Map();
  }
  get(t) {
    return this.cache.get(Array.isArray(t) ? t.join("%") : t) || null;
  }
  update(t, r) {
    const n = Array.isArray(t) ? t.join("%") : t, o = this.cache.get(n), a = r(o);
    a === null ? this.cache.delete(n) : this.cache.set(n, a);
  }
}
const Or = Ir, Ot = "data-token-hash", Y = "data-css-hash", Fr = "data-dev-cache-path", ne = "__cssinjs_instance__", we = Math.random().toString(12).slice(2);
function Ft() {
  if (typeof document < "u" && document.head && document.body) {
    const e = document.body.querySelectorAll(`style[${Y}]`) || [], {
      firstChild: t
    } = document.head;
    Array.from(e).forEach((n) => {
      n[ne] = n[ne] || we, document.head.insertBefore(n, t);
    });
    const r = {};
    Array.from(document.querySelectorAll(`style[${Y}]`)).forEach((n) => {
      var o;
      const a = n.getAttribute(Y);
      r[a] ? n[ne] === we && ((o = n.parentNode) === null || o === void 0 || o.removeChild(n)) : r[a] = !0;
    });
  }
  return new Or();
}
const Lt = Symbol("StyleContextKey"), ot = {
  cache: Ft(),
  defaultCache: !0,
  hashPriority: "low"
}, at = () => rt(Lt, Se(v({}, ot))), Lr = (e) => {
  const t = at(), r = Se(v({}, ot));
  return q([e, t], () => {
    const n = v({}, t.value), o = vr(e);
    Object.keys(o).forEach((i) => {
      const s = o[i];
      o[i] !== void 0 && (n[i] = s);
    });
    const {
      cache: a
    } = o;
    n.cache = n.cache || Ft(), n.defaultCache = !a && t.value.defaultCache, r.value = n;
  }, {
    immediate: !0
  }), tt(Lt, r), r;
}, _r = () => ({
  autoClear: Ee(),
  /** @private Test only. Not work in production. */
  mock: pt(),
  /**
   * Only set when you need ssr to extract style on you own.
   * If not provided, it will auto create <style /> on the end of Provider in server side.
   */
  cache: It(),
  /** Tell children that this context is default generated context */
  defaultCache: Ee(),
  /** Use `:where` selector to reduce hashId css selector priority */
  hashPriority: pt(),
  /** Tell cssinjs where to inject style in */
  container: Dr(),
  /** Component wil render inline  `<style />` for fallback in SSR. Not recommend. */
  ssrInline: Ee(),
  /** Transform css before inject in document. Please note that `transformers` do not support dynamic update */
  transformers: vt(),
  /**
   * Linters to lint css before inject in document.
   * Styles will be linted after transforming.
   * Please note that `linters` do not support dynamic update.
   */
  linters: vt()
});
Nr(se({
  name: "AStyleProvider",
  inheritAttrs: !1,
  props: Rr(_r(), ot),
  setup(e, t) {
    let {
      slots: r
    } = t;
    return Lr(e), () => {
      var n;
      return (n = r.default) === null || n === void 0 ? void 0 : n.call(r);
    };
  }
}));
function Xr() {
  return !1;
}
let Le = !1;
function Wr() {
  return Le;
}
const jr = process.env.NODE_ENV === "production" ? Xr : Wr;
if (process.env.NODE_ENV !== "production" && typeof module < "u" && module && module.hot) {
  const e = window;
  if (typeof e.webpackHotUpdate == "function") {
    const t = e.webpackHotUpdate;
    e.webpackHotUpdate = function() {
      return Le = !0, setTimeout(() => {
        Le = !1;
      }, 0), t(...arguments);
    };
  }
}
function _t(e, t, r, n) {
  const o = at(), a = Se(""), i = Se();
  Rt(() => {
    a.value = [e, ...t.value].join("%");
  });
  const s = jr(), c = (h) => {
    o.value.cache.update(h, (f) => {
      const [l = 0, u] = f || [];
      return l - 1 === 0 ? (n == null || n(u, !1), null) : [l - 1, u];
    });
  };
  return q(a, (h, f) => {
    f && c(f), o.value.cache.update(h, (l) => {
      const [u = 0, p] = l || [];
      let b = p;
      process.env.NODE_ENV !== "production" && p && s && (n == null || n(b, s), b = null);
      const y = b || r();
      return [u + 1, y];
    }), i.value = o.value.cache.get(a.value)[1];
  }, {
    immediate: !0
  }), Nt(() => {
    c(a.value);
  }), i;
}
function it() {
  return !!(typeof window < "u" && window.document && window.document.createElement);
}
function Gr(e, t) {
  return e && e.contains ? e.contains(t) : !1;
}
const mt = "data-vc-order", Vr = "vc-util-key", _e = /* @__PURE__ */ new Map();
function Xt() {
  let {
    mark: e
  } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
  return e ? e.startsWith("data-") ? e : `data-${e}` : Vr;
}
function Te(e) {
  return e.attachTo ? e.attachTo : document.querySelector("head") || document.body;
}
function Ur(e) {
  return e === "queue" ? "prependQueue" : e ? "prepend" : "append";
}
function Wt(e) {
  return Array.from((_e.get(e) || e).children).filter((t) => t.tagName === "STYLE");
}
function jt(e) {
  let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  if (!it())
    return null;
  const {
    csp: r,
    prepend: n
  } = t, o = document.createElement("style");
  o.setAttribute(mt, Ur(n)), r != null && r.nonce && (o.nonce = r == null ? void 0 : r.nonce), o.innerHTML = e;
  const a = Te(t), {
    firstChild: i
  } = a;
  if (n) {
    if (n === "queue") {
      const s = Wt(a).filter((c) => ["prepend", "prependQueue"].includes(c.getAttribute(mt)));
      if (s.length)
        return a.insertBefore(o, s[s.length - 1].nextSibling), o;
    }
    a.insertBefore(o, i);
  } else
    a.appendChild(o);
  return o;
}
function Gt(e) {
  let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  const r = Te(t);
  return Wt(r).find((n) => n.getAttribute(Xt(t)) === e);
}
function Vt(e) {
  let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  const r = Gt(e, t);
  r && Te(t).removeChild(r);
}
function Kr(e, t) {
  const r = _e.get(e);
  if (!r || !Gr(document, r)) {
    const n = jt("", t), {
      parentNode: o
    } = n;
    _e.set(e, o), e.removeChild(n);
  }
}
function Xe(e, t) {
  let r = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
  var n, o, a;
  const i = Te(r);
  Kr(i, r);
  const s = Gt(t, r);
  if (s)
    return !((n = r.csp) === null || n === void 0) && n.nonce && s.nonce !== ((o = r.csp) === null || o === void 0 ? void 0 : o.nonce) && (s.nonce = (a = r.csp) === null || a === void 0 ? void 0 : a.nonce), s.innerHTML !== e && (s.innerHTML = e), s;
  const c = jt(e, r);
  return c.setAttribute(Xt(r), t), c;
}
function Ce(e) {
  let t = "";
  return Object.keys(e).forEach((r) => {
    const n = e[r];
    t += r, n && typeof n == "object" ? t += Ce(n) : t += n;
  }), t;
}
function qr(e, t) {
  return nt(`${t}_${Ce(e)}`);
}
const oe = `layer-${Date.now()}-${Math.random()}`.replace(/\./g, ""), Ut = "903px";
function Yr(e, t) {
  var r;
  if (it()) {
    Xe(e, oe);
    const n = document.createElement("div");
    n.style.position = "fixed", n.style.left = "0", n.style.top = "0", t == null || t(n), document.body.appendChild(n), process.env.NODE_ENV !== "production" && (n.innerHTML = "Test", n.style.zIndex = "9999999");
    const o = getComputedStyle(n).width === Ut;
    return (r = n.parentNode) === null || r === void 0 || r.removeChild(n), Vt(oe), o;
  }
  return !1;
}
let ze;
function Qr() {
  return ze === void 0 && (ze = Yr(`@layer ${oe} { .${oe} { width: ${Ut}!important; } }`, (e) => {
    e.className = oe;
  })), ze;
}
const bt = {}, Jr = process.env.NODE_ENV !== "production" ? "css-dev-only-do-not-override" : "css", W = /* @__PURE__ */ new Map();
function Zr(e) {
  W.set(e, (W.get(e) || 0) + 1);
}
function en(e) {
  typeof document < "u" && document.querySelectorAll(`style[${Ot}="${e}"]`).forEach((r) => {
    var n;
    r[ne] === we && ((n = r.parentNode) === null || n === void 0 || n.removeChild(r));
  });
}
function tn(e) {
  W.set(e, (W.get(e) || 0) - 1);
  const t = Array.from(W.keys()), r = t.filter((n) => (W.get(n) || 0) <= 0);
  r.length < t.length && r.forEach((n) => {
    en(n), W.delete(n);
  });
}
function rn(e, t) {
  let r = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : $({});
  const n = k(() => v({}, ...t.value)), o = k(() => Ce(n.value)), a = k(() => Ce(r.value.override || bt));
  return _t("token", k(() => [r.value.salt || "", e.value.id, o.value, a.value]), () => {
    const {
      salt: s = "",
      override: c = bt,
      formatToken: h
    } = r.value, f = e.value.getDerivativeToken(n.value);
    let l = v(v({}, f), c);
    h && (l = h(l));
    const u = qr(l, s);
    l._tokenKey = u, Zr(u);
    const p = `${Jr}-${nt(u)}`;
    return l._hashId = p, [l, p];
  }, (s) => {
    tn(s[0]._tokenKey);
  });
}
var nn = {
  animationIterationCount: 1,
  aspectRatio: 1,
  borderImageOutset: 1,
  borderImageSlice: 1,
  borderImageWidth: 1,
  boxFlex: 1,
  boxFlexGroup: 1,
  boxOrdinalGroup: 1,
  columnCount: 1,
  columns: 1,
  flex: 1,
  flexGrow: 1,
  flexPositive: 1,
  flexShrink: 1,
  flexNegative: 1,
  flexOrder: 1,
  gridRow: 1,
  gridRowEnd: 1,
  gridRowSpan: 1,
  gridRowStart: 1,
  gridColumn: 1,
  gridColumnEnd: 1,
  gridColumnSpan: 1,
  gridColumnStart: 1,
  msGridRow: 1,
  msGridRowSpan: 1,
  msGridColumn: 1,
  msGridColumnSpan: 1,
  fontWeight: 1,
  lineHeight: 1,
  opacity: 1,
  order: 1,
  orphans: 1,
  tabSize: 1,
  widows: 1,
  zIndex: 1,
  zoom: 1,
  WebkitLineClamp: 1,
  // SVG-related properties
  fillOpacity: 1,
  floodOpacity: 1,
  stopOpacity: 1,
  strokeDasharray: 1,
  strokeDashoffset: 1,
  strokeMiterlimit: 1,
  strokeOpacity: 1,
  strokeWidth: 1
}, Kt = "comm", qt = "rule", Yt = "decl", on = "@import", an = "@keyframes", sn = "@layer", cn = Math.abs, st = String.fromCharCode;
function Qt(e) {
  return e.trim();
}
function me(e, t, r) {
  return e.replace(t, r);
}
function ln(e, t) {
  return e.indexOf(t);
}
function ae(e, t) {
  return e.charCodeAt(t) | 0;
}
function ie(e, t, r) {
  return e.slice(t, r);
}
function L(e) {
  return e.length;
}
function un(e) {
  return e.length;
}
function ue(e, t) {
  return t.push(e), e;
}
var Me = 1, Q = 1, Jt = 0, N = 0, H = 0, ee = "";
function ct(e, t, r, n, o, a, i, s) {
  return { value: e, root: t, parent: r, type: n, props: o, children: a, line: Me, column: Q, length: i, return: "", siblings: s };
}
function fn() {
  return H;
}
function dn() {
  return H = N > 0 ? ae(ee, --N) : 0, Q--, H === 10 && (Q = 1, Me--), H;
}
function D() {
  return H = N < Jt ? ae(ee, N++) : 0, Q++, H === 10 && (Q = 1, Me++), H;
}
function V() {
  return ae(ee, N);
}
function be() {
  return N;
}
function Ae(e, t) {
  return ie(ee, e, t);
}
function We(e) {
  switch (e) {
    case 0:
    case 9:
    case 10:
    case 13:
    case 32:
      return 5;
    case 33:
    case 43:
    case 44:
    case 47:
    case 62:
    case 64:
    case 126:
    case 59:
    case 123:
    case 125:
      return 4;
    case 58:
      return 3;
    case 34:
    case 39:
    case 40:
    case 91:
      return 2;
    case 41:
    case 93:
      return 1;
  }
  return 0;
}
function hn(e) {
  return Me = Q = 1, Jt = L(ee = e), N = 0, [];
}
function gn(e) {
  return ee = "", e;
}
function $e(e) {
  return Qt(Ae(N - 1, je(e === 91 ? e + 2 : e === 40 ? e + 1 : e)));
}
function vn(e) {
  for (; (H = V()) && H < 33; )
    D();
  return We(e) > 2 || We(H) > 3 ? "" : " ";
}
function pn(e, t) {
  for (; --t && D() && !(H < 48 || H > 102 || H > 57 && H < 65 || H > 70 && H < 97); )
    ;
  return Ae(e, be() + (t < 6 && V() == 32 && D() == 32));
}
function je(e) {
  for (; D(); )
    switch (H) {
      case e:
        return N;
      case 34:
      case 39:
        e !== 34 && e !== 39 && je(H);
        break;
      case 40:
        e === 41 && je(e);
        break;
      case 92:
        D();
        break;
    }
  return N;
}
function mn(e, t) {
  for (; D() && e + H !== 47 + 10; )
    if (e + H === 42 + 42 && V() === 47)
      break;
  return "/*" + Ae(t, N - 1) + "*" + st(e === 47 ? e : D());
}
function bn(e) {
  for (; !We(V()); )
    D();
  return Ae(e, N);
}
function yn(e) {
  return gn(ye("", null, null, null, [""], e = hn(e), 0, [0], e));
}
function ye(e, t, r, n, o, a, i, s, c) {
  for (var h = 0, f = 0, l = i, u = 0, p = 0, b = 0, y = 1, C = 1, x = 1, m = 0, w = "", M = o, S = a, A = n, d = w; C; )
    switch (b = m, m = D()) {
      case 40:
        if (b != 108 && ae(d, l - 1) == 58) {
          ln(d += me($e(m), "&", "&\f"), "&\f") != -1 && (x = -1);
          break;
        }
      case 34:
      case 39:
      case 91:
        d += $e(m);
        break;
      case 9:
      case 10:
      case 13:
      case 32:
        d += vn(b);
        break;
      case 92:
        d += pn(be() - 1, 7);
        continue;
      case 47:
        switch (V()) {
          case 42:
          case 47:
            ue(Sn(mn(D(), be()), t, r, c), c);
            break;
          default:
            d += "/";
        }
        break;
      case 123 * y:
        s[h++] = L(d) * x;
      case 125 * y:
      case 59:
      case 0:
        switch (m) {
          case 0:
          case 125:
            C = 0;
          case 59 + f:
            x == -1 && (d = me(d, /\f/g, "")), p > 0 && L(d) - l && ue(p > 32 ? St(d + ";", n, r, l - 1, c) : St(me(d, " ", "") + ";", n, r, l - 2, c), c);
            break;
          case 59:
            d += ";";
          default:
            if (ue(A = yt(d, t, r, h, f, o, s, w, M = [], S = [], l, a), a), m === 123)
              if (f === 0)
                ye(d, t, A, A, M, a, l, s, S);
              else
                switch (u === 99 && ae(d, 3) === 110 ? 100 : u) {
                  case 100:
                  case 108:
                  case 109:
                  case 115:
                    ye(e, A, A, n && ue(yt(e, A, A, 0, 0, o, s, w, o, M = [], l, S), S), o, S, l, s, n ? M : S);
                    break;
                  default:
                    ye(d, A, A, A, [""], S, 0, s, S);
                }
        }
        h = f = p = 0, y = x = 1, w = d = "", l = i;
        break;
      case 58:
        l = 1 + L(d), p = b;
      default:
        if (y < 1) {
          if (m == 123)
            --y;
          else if (m == 125 && y++ == 0 && dn() == 125)
            continue;
        }
        switch (d += st(m), m * y) {
          case 38:
            x = f > 0 ? 1 : (d += "\f", -1);
            break;
          case 44:
            s[h++] = (L(d) - 1) * x, x = 1;
            break;
          case 64:
            V() === 45 && (d += $e(D())), u = V(), f = l = L(w = d += bn(be())), m++;
            break;
          case 45:
            b === 45 && L(d) == 2 && (y = 0);
        }
    }
  return a;
}
function yt(e, t, r, n, o, a, i, s, c, h, f, l) {
  for (var u = o - 1, p = o === 0 ? a : [""], b = un(p), y = 0, C = 0, x = 0; y < n; ++y)
    for (var m = 0, w = ie(e, u + 1, u = cn(C = i[y])), M = e; m < b; ++m)
      (M = Qt(C > 0 ? p[m] + " " + w : me(w, /&\f/g, p[m]))) && (c[x++] = M);
  return ct(e, t, r, o === 0 ? qt : s, c, h, f, l);
}
function Sn(e, t, r, n) {
  return ct(e, t, r, Kt, st(fn()), ie(e, 2, -2), 0, n);
}
function St(e, t, r, n, o) {
  return ct(e, t, r, Yt, ie(e, 0, n), ie(e, n + 1, -1), n, o);
}
function Ge(e, t) {
  for (var r = "", n = 0; n < e.length; n++)
    r += t(e[n], n, e, t) || "";
  return r;
}
function xn(e, t, r, n) {
  switch (e.type) {
    case sn:
      if (e.children.length)
        break;
    case on:
    case Yt:
      return e.return = e.return || e.value;
    case Kt:
      return "";
    case an:
      return e.return = e.value + "{" + Ge(e.children, n) + "}";
    case qt:
      if (!L(e.value = e.props.join(",")))
        return "";
  }
  return L(r = Ge(e.children, n)) ? e.return = e.value + "{" + r + "}" : "";
}
let Ve = {};
function wn(e, t) {
  process.env.NODE_ENV !== "production" && !e && console !== void 0 && console.error(`Warning: ${t}`);
}
function Cn() {
  Ve = {};
}
function Tn(e, t, r) {
  !t && !Ve[r] && (e(!1, r), Ve[r] = !0);
}
function Zt(e, t) {
  Tn(wn, e, t);
}
function er(e, t) {
  const {
    path: r,
    parentSelectors: n
  } = t;
  Zt(!1, `[Ant Design Vue CSS-in-JS] ${r ? `Error in '${r}': ` : ""}${e}${n.length ? ` Selector info: ${n.join(" -> ")}` : ""}`);
}
const Mn = (e, t, r) => {
  if (e === "content") {
    const n = /(attr|counters?|url|(((repeating-)?(linear|radial))|conic)-gradient)\(|(no-)?(open|close)-quote/;
    (typeof t != "string" || ["normal", "none", "initial", "inherit", "unset"].indexOf(t) === -1 && !n.test(t) && (t.charAt(0) !== t.charAt(t.length - 1) || t.charAt(0) !== '"' && t.charAt(0) !== "'")) && er(`You seem to be using a value for 'content' without quotes, try replacing it with \`content: '"${t}"'\`.`, r);
  }
}, An = Mn, kn = (e, t, r) => {
  e === "animation" && r.hashId && t !== "none" && er(`You seem to be using hashed animation '${t}', in which case 'animationName' with Keyframe as value is recommended.`, r);
}, Hn = kn, xt = it(), tr = "_skip_check_";
function wt(e) {
  return Ge(yn(e), xn).replace(/\{%%%\:[^;];}/g, ";");
}
function En(e) {
  return typeof e == "object" && e && tr in e;
}
function zn(e, t, r) {
  if (!t)
    return e;
  const n = `.${t}`, o = r === "low" ? `:where(${n})` : n;
  return e.split(",").map((i) => {
    var s;
    const c = i.trim().split(/\s+/);
    let h = c[0] || "";
    const f = ((s = h.match(/^\w+/)) === null || s === void 0 ? void 0 : s[0]) || "";
    return h = `${f}${o}${h.slice(f.length)}`, [h, ...c.slice(1)].join(" ");
  }).join(",");
}
const Ue = /* @__PURE__ */ new Set();
process.env.NODE_ENV;
const Ke = function(e) {
  let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, {
    root: r,
    injectHash: n,
    parentSelectors: o
  } = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {
    root: !0,
    parentSelectors: []
  };
  const {
    hashId: a,
    layer: i,
    path: s,
    hashPriority: c,
    transformers: h = [],
    linters: f = []
  } = t;
  let l = "", u = {};
  function p(C) {
    const x = C.getName(a);
    if (!u[x]) {
      const [m] = Ke(C.style, t, {
        root: !1,
        parentSelectors: o
      });
      u[x] = `@keyframes ${C.getName(a)}${m}`;
    }
  }
  function b(C) {
    let x = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : [];
    return C.forEach((m) => {
      Array.isArray(m) ? b(m, x) : m && x.push(m);
    }), x;
  }
  if (b(Array.isArray(e) ? e : [e]).forEach((C) => {
    const x = typeof C == "string" && !r ? {} : C;
    if (typeof x == "string")
      l += `${x}
`;
    else if (x._keyframe)
      p(x);
    else {
      const m = h.reduce((w, M) => {
        var S;
        return ((S = M == null ? void 0 : M.visit) === null || S === void 0 ? void 0 : S.call(M, w)) || w;
      }, x);
      Object.keys(m).forEach((w) => {
        var M;
        const S = m[w];
        if (typeof S == "object" && S && (w !== "animationName" || !S._keyframe) && !En(S)) {
          let A = !1, d = w.trim(), T = !1;
          (r || n) && a ? d.startsWith("@") ? A = !0 : d = zn(w, a, c) : r && !a && (d === "&" || d === "") && (d = "", T = !0);
          const [g, z] = Ke(S, t, {
            root: T,
            injectHash: A,
            parentSelectors: [...o, d]
          });
          u = v(v({}, u), z), l += `${d}${g}`;
        } else {
          const A = (M = S == null ? void 0 : S.value) !== null && M !== void 0 ? M : S;
          process.env.NODE_ENV !== "production" && (typeof S != "object" || !(S != null && S[tr])) && [An, Hn, ...f].forEach((g) => g(w, A, {
            path: s,
            hashId: a,
            parentSelectors: o
          }));
          const d = w.replace(/[A-Z]/g, (g) => `-${g.toLowerCase()}`);
          let T = A;
          !nn[w] && typeof T == "number" && T !== 0 && (T = `${T}px`), w === "animationName" && (S != null && S._keyframe) && (p(S), T = S.getName(a)), l += `${d}:${T};`;
        }
      });
    }
  }), !r)
    l = `{${l}}`;
  else if (i && Qr()) {
    const C = i.split(",");
    l = `@layer ${C[C.length - 1].trim()} {${l}}`, C.length > 1 && (l = `@layer ${i}{%%%:%}${l}`);
  }
  return [l, u];
};
function $n(e, t) {
  return nt(`${e.join("%")}${t}`);
}
function Ct(e, t) {
  const r = at(), n = k(() => e.value.token._tokenKey), o = k(() => [n.value, ...e.value.path]);
  let a = xt;
  return process.env.NODE_ENV !== "production" && r.value.mock !== void 0 && (a = r.value.mock === "client"), _t(
    "style",
    o,
    // Create cache if needed
    () => {
      const i = t(), {
        hashPriority: s,
        container: c,
        transformers: h,
        linters: f
      } = r.value, {
        path: l,
        hashId: u,
        layer: p
      } = e.value, [b, y] = Ke(i, {
        hashId: u,
        hashPriority: s,
        layer: p,
        path: l.join("-"),
        transformers: h,
        linters: f
      }), C = wt(b), x = $n(o.value, C);
      if (a) {
        const m = Xe(C, x, {
          mark: Y,
          prepend: "queue",
          attachTo: c
        });
        m[ne] = we, m.setAttribute(Ot, n.value), process.env.NODE_ENV !== "production" && m.setAttribute(Fr, o.value.join("|")), Object.keys(y).forEach((w) => {
          Ue.has(w) || (Ue.add(w), Xe(wt(y[w]), `_effect-${w}`, {
            mark: Y,
            prepend: "queue",
            attachTo: c
          }));
        });
      }
      return [C, n.value, x];
    },
    // Remove cache if no need
    (i, s) => {
      let [, , c] = i;
      (s || r.value.autoClear) && xt && Vt(c, {
        mark: Y
      });
    }
  ), (i) => i;
}
function Pn(e, t) {
  if (e.length !== t.length)
    return !1;
  for (let r = 0; r < e.length; r++)
    if (e[r] !== t[r])
      return !1;
  return !0;
}
class J {
  constructor() {
    this.cache = /* @__PURE__ */ new Map(), this.keys = [], this.cacheCallTimes = 0;
  }
  size() {
    return this.keys.length;
  }
  internalGet(t) {
    let r = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : !1, n = {
      map: this.cache
    };
    return t.forEach((o) => {
      var a;
      n ? n = (a = n == null ? void 0 : n.map) === null || a === void 0 ? void 0 : a.get(o) : n = void 0;
    }), n != null && n.value && r && (n.value[1] = this.cacheCallTimes++), n == null ? void 0 : n.value;
  }
  get(t) {
    var r;
    return (r = this.internalGet(t, !0)) === null || r === void 0 ? void 0 : r[0];
  }
  has(t) {
    return !!this.internalGet(t);
  }
  set(t, r) {
    if (!this.has(t)) {
      if (this.size() + 1 > J.MAX_CACHE_SIZE + J.MAX_CACHE_OFFSET) {
        const [o] = this.keys.reduce((a, i) => {
          const [, s] = a;
          return this.internalGet(i)[1] < s ? [i, this.internalGet(i)[1]] : a;
        }, [this.keys[0], this.cacheCallTimes]);
        this.delete(o);
      }
      this.keys.push(t);
    }
    let n = this.cache;
    t.forEach((o, a) => {
      if (a === t.length - 1)
        n.set(o, {
          value: [r, this.cacheCallTimes++]
        });
      else {
        const i = n.get(o);
        i ? i.map || (i.map = /* @__PURE__ */ new Map()) : n.set(o, {
          map: /* @__PURE__ */ new Map()
        }), n = n.get(o).map;
      }
    });
  }
  deleteByPath(t, r) {
    var n;
    const o = t.get(r[0]);
    if (r.length === 1)
      return o.map ? t.set(r[0], {
        map: o.map
      }) : t.delete(r[0]), (n = o.value) === null || n === void 0 ? void 0 : n[0];
    const a = this.deleteByPath(o.map, r.slice(1));
    return (!o.map || o.map.size === 0) && !o.value && t.delete(r[0]), a;
  }
  delete(t) {
    if (this.has(t))
      return this.keys = this.keys.filter((r) => !Pn(r, t)), this.deleteByPath(this.cache, t);
  }
}
J.MAX_CACHE_SIZE = 20;
J.MAX_CACHE_OFFSET = 5;
function Rn() {
}
let rr = Rn;
process.env.NODE_ENV !== "production" && (rr = (e, t, r) => {
  Zt(e, `[ant-design-vue: ${t}] ${r}`), process.env.NODE_ENV === "test" && Cn();
});
const Nn = rr;
let Tt = 0;
class Bn {
  constructor(t) {
    this.derivatives = Array.isArray(t) ? t : [t], this.id = Tt, t.length === 0 && Nn(t.length > 0, "[Ant Design Vue CSS-in-JS] Theme should have at least one derivative function."), Tt += 1;
  }
  getDerivativeToken(t) {
    return this.derivatives.reduce((r, n) => n(t, r), void 0);
  }
}
const Pe = new J();
function Dn(e) {
  const t = Array.isArray(e) ? e : [e];
  return Pe.has(t) || Pe.set(t, new Bn(t)), Pe.get(t);
}
const In = "4.0.0";
function E(e, t) {
  On(e) && (e = "100%");
  var r = Fn(e);
  return e = t === 360 ? e : Math.min(t, Math.max(0, parseFloat(e))), r && (e = parseInt(String(e * t), 10) / 100), Math.abs(e - t) < 1e-6 ? 1 : (t === 360 ? e = (e < 0 ? e % t + t : e % t) / parseFloat(String(t)) : e = e % t / parseFloat(String(t)), e);
}
function fe(e) {
  return Math.min(1, Math.max(0, e));
}
function On(e) {
  return typeof e == "string" && e.indexOf(".") !== -1 && parseFloat(e) === 1;
}
function Fn(e) {
  return typeof e == "string" && e.indexOf("%") !== -1;
}
function nr(e) {
  return e = parseFloat(e), (isNaN(e) || e < 0 || e > 1) && (e = 1), e;
}
function de(e) {
  return e <= 1 ? "".concat(Number(e) * 100, "%") : e;
}
function G(e) {
  return e.length === 1 ? "0" + e : String(e);
}
function Ln(e, t, r) {
  return {
    r: E(e, 255) * 255,
    g: E(t, 255) * 255,
    b: E(r, 255) * 255
  };
}
function Mt(e, t, r) {
  e = E(e, 255), t = E(t, 255), r = E(r, 255);
  var n = Math.max(e, t, r), o = Math.min(e, t, r), a = 0, i = 0, s = (n + o) / 2;
  if (n === o)
    i = 0, a = 0;
  else {
    var c = n - o;
    switch (i = s > 0.5 ? c / (2 - n - o) : c / (n + o), n) {
      case e:
        a = (t - r) / c + (t < r ? 6 : 0);
        break;
      case t:
        a = (r - e) / c + 2;
        break;
      case r:
        a = (e - t) / c + 4;
        break;
    }
    a /= 6;
  }
  return { h: a, s: i, l: s };
}
function Re(e, t, r) {
  return r < 0 && (r += 1), r > 1 && (r -= 1), r < 1 / 6 ? e + (t - e) * (6 * r) : r < 1 / 2 ? t : r < 2 / 3 ? e + (t - e) * (2 / 3 - r) * 6 : e;
}
function _n(e, t, r) {
  var n, o, a;
  if (e = E(e, 360), t = E(t, 100), r = E(r, 100), t === 0)
    o = r, a = r, n = r;
  else {
    var i = r < 0.5 ? r * (1 + t) : r + t - r * t, s = 2 * r - i;
    n = Re(s, i, e + 1 / 3), o = Re(s, i, e), a = Re(s, i, e - 1 / 3);
  }
  return { r: n * 255, g: o * 255, b: a * 255 };
}
function qe(e, t, r) {
  e = E(e, 255), t = E(t, 255), r = E(r, 255);
  var n = Math.max(e, t, r), o = Math.min(e, t, r), a = 0, i = n, s = n - o, c = n === 0 ? 0 : s / n;
  if (n === o)
    a = 0;
  else {
    switch (n) {
      case e:
        a = (t - r) / s + (t < r ? 6 : 0);
        break;
      case t:
        a = (r - e) / s + 2;
        break;
      case r:
        a = (e - t) / s + 4;
        break;
    }
    a /= 6;
  }
  return { h: a, s: c, v: i };
}
function Xn(e, t, r) {
  e = E(e, 360) * 6, t = E(t, 100), r = E(r, 100);
  var n = Math.floor(e), o = e - n, a = r * (1 - t), i = r * (1 - o * t), s = r * (1 - (1 - o) * t), c = n % 6, h = [r, i, a, a, s, r][c], f = [s, r, r, i, a, a][c], l = [a, a, s, r, r, i][c];
  return { r: h * 255, g: f * 255, b: l * 255 };
}
function Ye(e, t, r, n) {
  var o = [
    G(Math.round(e).toString(16)),
    G(Math.round(t).toString(16)),
    G(Math.round(r).toString(16))
  ];
  return n && o[0].startsWith(o[0].charAt(1)) && o[1].startsWith(o[1].charAt(1)) && o[2].startsWith(o[2].charAt(1)) ? o[0].charAt(0) + o[1].charAt(0) + o[2].charAt(0) : o.join("");
}
function Wn(e, t, r, n, o) {
  var a = [
    G(Math.round(e).toString(16)),
    G(Math.round(t).toString(16)),
    G(Math.round(r).toString(16)),
    G(jn(n))
  ];
  return o && a[0].startsWith(a[0].charAt(1)) && a[1].startsWith(a[1].charAt(1)) && a[2].startsWith(a[2].charAt(1)) && a[3].startsWith(a[3].charAt(1)) ? a[0].charAt(0) + a[1].charAt(0) + a[2].charAt(0) + a[3].charAt(0) : a.join("");
}
function jn(e) {
  return Math.round(parseFloat(e) * 255).toString(16);
}
function At(e) {
  return P(e) / 255;
}
function P(e) {
  return parseInt(e, 16);
}
function Gn(e) {
  return {
    r: e >> 16,
    g: (e & 65280) >> 8,
    b: e & 255
  };
}
var Qe = {
  aliceblue: "#f0f8ff",
  antiquewhite: "#faebd7",
  aqua: "#00ffff",
  aquamarine: "#7fffd4",
  azure: "#f0ffff",
  beige: "#f5f5dc",
  bisque: "#ffe4c4",
  black: "#000000",
  blanchedalmond: "#ffebcd",
  blue: "#0000ff",
  blueviolet: "#8a2be2",
  brown: "#a52a2a",
  burlywood: "#deb887",
  cadetblue: "#5f9ea0",
  chartreuse: "#7fff00",
  chocolate: "#d2691e",
  coral: "#ff7f50",
  cornflowerblue: "#6495ed",
  cornsilk: "#fff8dc",
  crimson: "#dc143c",
  cyan: "#00ffff",
  darkblue: "#00008b",
  darkcyan: "#008b8b",
  darkgoldenrod: "#b8860b",
  darkgray: "#a9a9a9",
  darkgreen: "#006400",
  darkgrey: "#a9a9a9",
  darkkhaki: "#bdb76b",
  darkmagenta: "#8b008b",
  darkolivegreen: "#556b2f",
  darkorange: "#ff8c00",
  darkorchid: "#9932cc",
  darkred: "#8b0000",
  darksalmon: "#e9967a",
  darkseagreen: "#8fbc8f",
  darkslateblue: "#483d8b",
  darkslategray: "#2f4f4f",
  darkslategrey: "#2f4f4f",
  darkturquoise: "#00ced1",
  darkviolet: "#9400d3",
  deeppink: "#ff1493",
  deepskyblue: "#00bfff",
  dimgray: "#696969",
  dimgrey: "#696969",
  dodgerblue: "#1e90ff",
  firebrick: "#b22222",
  floralwhite: "#fffaf0",
  forestgreen: "#228b22",
  fuchsia: "#ff00ff",
  gainsboro: "#dcdcdc",
  ghostwhite: "#f8f8ff",
  goldenrod: "#daa520",
  gold: "#ffd700",
  gray: "#808080",
  green: "#008000",
  greenyellow: "#adff2f",
  grey: "#808080",
  honeydew: "#f0fff0",
  hotpink: "#ff69b4",
  indianred: "#cd5c5c",
  indigo: "#4b0082",
  ivory: "#fffff0",
  khaki: "#f0e68c",
  lavenderblush: "#fff0f5",
  lavender: "#e6e6fa",
  lawngreen: "#7cfc00",
  lemonchiffon: "#fffacd",
  lightblue: "#add8e6",
  lightcoral: "#f08080",
  lightcyan: "#e0ffff",
  lightgoldenrodyellow: "#fafad2",
  lightgray: "#d3d3d3",
  lightgreen: "#90ee90",
  lightgrey: "#d3d3d3",
  lightpink: "#ffb6c1",
  lightsalmon: "#ffa07a",
  lightseagreen: "#20b2aa",
  lightskyblue: "#87cefa",
  lightslategray: "#778899",
  lightslategrey: "#778899",
  lightsteelblue: "#b0c4de",
  lightyellow: "#ffffe0",
  lime: "#00ff00",
  limegreen: "#32cd32",
  linen: "#faf0e6",
  magenta: "#ff00ff",
  maroon: "#800000",
  mediumaquamarine: "#66cdaa",
  mediumblue: "#0000cd",
  mediumorchid: "#ba55d3",
  mediumpurple: "#9370db",
  mediumseagreen: "#3cb371",
  mediumslateblue: "#7b68ee",
  mediumspringgreen: "#00fa9a",
  mediumturquoise: "#48d1cc",
  mediumvioletred: "#c71585",
  midnightblue: "#191970",
  mintcream: "#f5fffa",
  mistyrose: "#ffe4e1",
  moccasin: "#ffe4b5",
  navajowhite: "#ffdead",
  navy: "#000080",
  oldlace: "#fdf5e6",
  olive: "#808000",
  olivedrab: "#6b8e23",
  orange: "#ffa500",
  orangered: "#ff4500",
  orchid: "#da70d6",
  palegoldenrod: "#eee8aa",
  palegreen: "#98fb98",
  paleturquoise: "#afeeee",
  palevioletred: "#db7093",
  papayawhip: "#ffefd5",
  peachpuff: "#ffdab9",
  peru: "#cd853f",
  pink: "#ffc0cb",
  plum: "#dda0dd",
  powderblue: "#b0e0e6",
  purple: "#800080",
  rebeccapurple: "#663399",
  red: "#ff0000",
  rosybrown: "#bc8f8f",
  royalblue: "#4169e1",
  saddlebrown: "#8b4513",
  salmon: "#fa8072",
  sandybrown: "#f4a460",
  seagreen: "#2e8b57",
  seashell: "#fff5ee",
  sienna: "#a0522d",
  silver: "#c0c0c0",
  skyblue: "#87ceeb",
  slateblue: "#6a5acd",
  slategray: "#708090",
  slategrey: "#708090",
  snow: "#fffafa",
  springgreen: "#00ff7f",
  steelblue: "#4682b4",
  tan: "#d2b48c",
  teal: "#008080",
  thistle: "#d8bfd8",
  tomato: "#ff6347",
  turquoise: "#40e0d0",
  violet: "#ee82ee",
  wheat: "#f5deb3",
  white: "#ffffff",
  whitesmoke: "#f5f5f5",
  yellow: "#ffff00",
  yellowgreen: "#9acd32"
};
function K(e) {
  var t = { r: 0, g: 0, b: 0 }, r = 1, n = null, o = null, a = null, i = !1, s = !1;
  return typeof e == "string" && (e = Kn(e)), typeof e == "object" && (O(e.r) && O(e.g) && O(e.b) ? (t = Ln(e.r, e.g, e.b), i = !0, s = String(e.r).substr(-1) === "%" ? "prgb" : "rgb") : O(e.h) && O(e.s) && O(e.v) ? (n = de(e.s), o = de(e.v), t = Xn(e.h, n, o), i = !0, s = "hsv") : O(e.h) && O(e.s) && O(e.l) && (n = de(e.s), a = de(e.l), t = _n(e.h, n, a), i = !0, s = "hsl"), Object.prototype.hasOwnProperty.call(e, "a") && (r = e.a)), r = nr(r), {
    ok: i,
    format: e.format || s,
    r: Math.min(255, Math.max(t.r, 0)),
    g: Math.min(255, Math.max(t.g, 0)),
    b: Math.min(255, Math.max(t.b, 0)),
    a: r
  };
}
var Vn = "[-\\+]?\\d+%?", Un = "[-\\+]?\\d*\\.\\d+%?", X = "(?:".concat(Un, ")|(?:").concat(Vn, ")"), Ne = "[\\s|\\(]+(".concat(X, ")[,|\\s]+(").concat(X, ")[,|\\s]+(").concat(X, ")\\s*\\)?"), Be = "[\\s|\\(]+(".concat(X, ")[,|\\s]+(").concat(X, ")[,|\\s]+(").concat(X, ")[,|\\s]+(").concat(X, ")\\s*\\)?"), B = {
  CSS_UNIT: new RegExp(X),
  rgb: new RegExp("rgb" + Ne),
  rgba: new RegExp("rgba" + Be),
  hsl: new RegExp("hsl" + Ne),
  hsla: new RegExp("hsla" + Be),
  hsv: new RegExp("hsv" + Ne),
  hsva: new RegExp("hsva" + Be),
  hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
  hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
  hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
  hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/
};
function Kn(e) {
  if (e = e.trim().toLowerCase(), e.length === 0)
    return !1;
  var t = !1;
  if (Qe[e])
    e = Qe[e], t = !0;
  else if (e === "transparent")
    return { r: 0, g: 0, b: 0, a: 0, format: "name" };
  var r = B.rgb.exec(e);
  return r ? { r: r[1], g: r[2], b: r[3] } : (r = B.rgba.exec(e), r ? { r: r[1], g: r[2], b: r[3], a: r[4] } : (r = B.hsl.exec(e), r ? { h: r[1], s: r[2], l: r[3] } : (r = B.hsla.exec(e), r ? { h: r[1], s: r[2], l: r[3], a: r[4] } : (r = B.hsv.exec(e), r ? { h: r[1], s: r[2], v: r[3] } : (r = B.hsva.exec(e), r ? { h: r[1], s: r[2], v: r[3], a: r[4] } : (r = B.hex8.exec(e), r ? {
    r: P(r[1]),
    g: P(r[2]),
    b: P(r[3]),
    a: At(r[4]),
    format: t ? "name" : "hex8"
  } : (r = B.hex6.exec(e), r ? {
    r: P(r[1]),
    g: P(r[2]),
    b: P(r[3]),
    format: t ? "name" : "hex"
  } : (r = B.hex4.exec(e), r ? {
    r: P(r[1] + r[1]),
    g: P(r[2] + r[2]),
    b: P(r[3] + r[3]),
    a: At(r[4] + r[4]),
    format: t ? "name" : "hex8"
  } : (r = B.hex3.exec(e), r ? {
    r: P(r[1] + r[1]),
    g: P(r[2] + r[2]),
    b: P(r[3] + r[3]),
    format: t ? "name" : "hex"
  } : !1)))))))));
}
function O(e) {
  return !!B.CSS_UNIT.exec(String(e));
}
var R = (
  /** @class */
  function() {
    function e(t, r) {
      t === void 0 && (t = ""), r === void 0 && (r = {});
      var n;
      if (t instanceof e)
        return t;
      typeof t == "number" && (t = Gn(t)), this.originalInput = t;
      var o = K(t);
      this.originalInput = t, this.r = o.r, this.g = o.g, this.b = o.b, this.a = o.a, this.roundA = Math.round(100 * this.a) / 100, this.format = (n = r.format) !== null && n !== void 0 ? n : o.format, this.gradientType = r.gradientType, this.r < 1 && (this.r = Math.round(this.r)), this.g < 1 && (this.g = Math.round(this.g)), this.b < 1 && (this.b = Math.round(this.b)), this.isValid = o.ok;
    }
    return e.prototype.isDark = function() {
      return this.getBrightness() < 128;
    }, e.prototype.isLight = function() {
      return !this.isDark();
    }, e.prototype.getBrightness = function() {
      var t = this.toRgb();
      return (t.r * 299 + t.g * 587 + t.b * 114) / 1e3;
    }, e.prototype.getLuminance = function() {
      var t = this.toRgb(), r, n, o, a = t.r / 255, i = t.g / 255, s = t.b / 255;
      return a <= 0.03928 ? r = a / 12.92 : r = Math.pow((a + 0.055) / 1.055, 2.4), i <= 0.03928 ? n = i / 12.92 : n = Math.pow((i + 0.055) / 1.055, 2.4), s <= 0.03928 ? o = s / 12.92 : o = Math.pow((s + 0.055) / 1.055, 2.4), 0.2126 * r + 0.7152 * n + 0.0722 * o;
    }, e.prototype.getAlpha = function() {
      return this.a;
    }, e.prototype.setAlpha = function(t) {
      return this.a = nr(t), this.roundA = Math.round(100 * this.a) / 100, this;
    }, e.prototype.isMonochrome = function() {
      var t = this.toHsl().s;
      return t === 0;
    }, e.prototype.toHsv = function() {
      var t = qe(this.r, this.g, this.b);
      return { h: t.h * 360, s: t.s, v: t.v, a: this.a };
    }, e.prototype.toHsvString = function() {
      var t = qe(this.r, this.g, this.b), r = Math.round(t.h * 360), n = Math.round(t.s * 100), o = Math.round(t.v * 100);
      return this.a === 1 ? "hsv(".concat(r, ", ").concat(n, "%, ").concat(o, "%)") : "hsva(".concat(r, ", ").concat(n, "%, ").concat(o, "%, ").concat(this.roundA, ")");
    }, e.prototype.toHsl = function() {
      var t = Mt(this.r, this.g, this.b);
      return { h: t.h * 360, s: t.s, l: t.l, a: this.a };
    }, e.prototype.toHslString = function() {
      var t = Mt(this.r, this.g, this.b), r = Math.round(t.h * 360), n = Math.round(t.s * 100), o = Math.round(t.l * 100);
      return this.a === 1 ? "hsl(".concat(r, ", ").concat(n, "%, ").concat(o, "%)") : "hsla(".concat(r, ", ").concat(n, "%, ").concat(o, "%, ").concat(this.roundA, ")");
    }, e.prototype.toHex = function(t) {
      return t === void 0 && (t = !1), Ye(this.r, this.g, this.b, t);
    }, e.prototype.toHexString = function(t) {
      return t === void 0 && (t = !1), "#" + this.toHex(t);
    }, e.prototype.toHex8 = function(t) {
      return t === void 0 && (t = !1), Wn(this.r, this.g, this.b, this.a, t);
    }, e.prototype.toHex8String = function(t) {
      return t === void 0 && (t = !1), "#" + this.toHex8(t);
    }, e.prototype.toRgb = function() {
      return {
        r: Math.round(this.r),
        g: Math.round(this.g),
        b: Math.round(this.b),
        a: this.a
      };
    }, e.prototype.toRgbString = function() {
      var t = Math.round(this.r), r = Math.round(this.g), n = Math.round(this.b);
      return this.a === 1 ? "rgb(".concat(t, ", ").concat(r, ", ").concat(n, ")") : "rgba(".concat(t, ", ").concat(r, ", ").concat(n, ", ").concat(this.roundA, ")");
    }, e.prototype.toPercentageRgb = function() {
      var t = function(r) {
        return "".concat(Math.round(E(r, 255) * 100), "%");
      };
      return {
        r: t(this.r),
        g: t(this.g),
        b: t(this.b),
        a: this.a
      };
    }, e.prototype.toPercentageRgbString = function() {
      var t = function(r) {
        return Math.round(E(r, 255) * 100);
      };
      return this.a === 1 ? "rgb(".concat(t(this.r), "%, ").concat(t(this.g), "%, ").concat(t(this.b), "%)") : "rgba(".concat(t(this.r), "%, ").concat(t(this.g), "%, ").concat(t(this.b), "%, ").concat(this.roundA, ")");
    }, e.prototype.toName = function() {
      if (this.a === 0)
        return "transparent";
      if (this.a < 1)
        return !1;
      for (var t = "#" + Ye(this.r, this.g, this.b, !1), r = 0, n = Object.entries(Qe); r < n.length; r++) {
        var o = n[r], a = o[0], i = o[1];
        if (t === i)
          return a;
      }
      return !1;
    }, e.prototype.toString = function(t) {
      var r = !!t;
      t = t ?? this.format;
      var n = !1, o = this.a < 1 && this.a >= 0, a = !r && o && (t.startsWith("hex") || t === "name");
      return a ? t === "name" && this.a === 0 ? this.toName() : this.toRgbString() : (t === "rgb" && (n = this.toRgbString()), t === "prgb" && (n = this.toPercentageRgbString()), (t === "hex" || t === "hex6") && (n = this.toHexString()), t === "hex3" && (n = this.toHexString(!0)), t === "hex4" && (n = this.toHex8String(!0)), t === "hex8" && (n = this.toHex8String()), t === "name" && (n = this.toName()), t === "hsl" && (n = this.toHslString()), t === "hsv" && (n = this.toHsvString()), n || this.toHexString());
    }, e.prototype.toNumber = function() {
      return (Math.round(this.r) << 16) + (Math.round(this.g) << 8) + Math.round(this.b);
    }, e.prototype.clone = function() {
      return new e(this.toString());
    }, e.prototype.lighten = function(t) {
      t === void 0 && (t = 10);
      var r = this.toHsl();
      return r.l += t / 100, r.l = fe(r.l), new e(r);
    }, e.prototype.brighten = function(t) {
      t === void 0 && (t = 10);
      var r = this.toRgb();
      return r.r = Math.max(0, Math.min(255, r.r - Math.round(255 * -(t / 100)))), r.g = Math.max(0, Math.min(255, r.g - Math.round(255 * -(t / 100)))), r.b = Math.max(0, Math.min(255, r.b - Math.round(255 * -(t / 100)))), new e(r);
    }, e.prototype.darken = function(t) {
      t === void 0 && (t = 10);
      var r = this.toHsl();
      return r.l -= t / 100, r.l = fe(r.l), new e(r);
    }, e.prototype.tint = function(t) {
      return t === void 0 && (t = 10), this.mix("white", t);
    }, e.prototype.shade = function(t) {
      return t === void 0 && (t = 10), this.mix("black", t);
    }, e.prototype.desaturate = function(t) {
      t === void 0 && (t = 10);
      var r = this.toHsl();
      return r.s -= t / 100, r.s = fe(r.s), new e(r);
    }, e.prototype.saturate = function(t) {
      t === void 0 && (t = 10);
      var r = this.toHsl();
      return r.s += t / 100, r.s = fe(r.s), new e(r);
    }, e.prototype.greyscale = function() {
      return this.desaturate(100);
    }, e.prototype.spin = function(t) {
      var r = this.toHsl(), n = (r.h + t) % 360;
      return r.h = n < 0 ? 360 + n : n, new e(r);
    }, e.prototype.mix = function(t, r) {
      r === void 0 && (r = 50);
      var n = this.toRgb(), o = new e(t).toRgb(), a = r / 100, i = {
        r: (o.r - n.r) * a + n.r,
        g: (o.g - n.g) * a + n.g,
        b: (o.b - n.b) * a + n.b,
        a: (o.a - n.a) * a + n.a
      };
      return new e(i);
    }, e.prototype.analogous = function(t, r) {
      t === void 0 && (t = 6), r === void 0 && (r = 30);
      var n = this.toHsl(), o = 360 / r, a = [this];
      for (n.h = (n.h - (o * t >> 1) + 720) % 360; --t; )
        n.h = (n.h + o) % 360, a.push(new e(n));
      return a;
    }, e.prototype.complement = function() {
      var t = this.toHsl();
      return t.h = (t.h + 180) % 360, new e(t);
    }, e.prototype.monochromatic = function(t) {
      t === void 0 && (t = 6);
      for (var r = this.toHsv(), n = r.h, o = r.s, a = r.v, i = [], s = 1 / t; t--; )
        i.push(new e({ h: n, s: o, v: a })), a = (a + s) % 1;
      return i;
    }, e.prototype.splitcomplement = function() {
      var t = this.toHsl(), r = t.h;
      return [
        this,
        new e({ h: (r + 72) % 360, s: t.s, l: t.l }),
        new e({ h: (r + 216) % 360, s: t.s, l: t.l })
      ];
    }, e.prototype.onBackground = function(t) {
      var r = this.toRgb(), n = new e(t).toRgb();
      return new e({
        r: n.r + (r.r - n.r) * r.a,
        g: n.g + (r.g - n.g) * r.a,
        b: n.b + (r.b - n.b) * r.a
      });
    }, e.prototype.triad = function() {
      return this.polyad(3);
    }, e.prototype.tetrad = function() {
      return this.polyad(4);
    }, e.prototype.polyad = function(t) {
      for (var r = this.toHsl(), n = r.h, o = [this], a = 360 / t, i = 1; i < t; i++)
        o.push(new e({ h: (n + i * a) % 360, s: r.s, l: r.l }));
      return o;
    }, e.prototype.equals = function(t) {
      return this.toRgbString() === new e(t).toRgbString();
    }, e;
  }()
), he = 2, kt = 0.16, qn = 0.05, Yn = 0.05, Qn = 0.15, or = 5, ar = 4, Jn = [{
  index: 7,
  opacity: 0.15
}, {
  index: 6,
  opacity: 0.25
}, {
  index: 5,
  opacity: 0.3
}, {
  index: 5,
  opacity: 0.45
}, {
  index: 5,
  opacity: 0.65
}, {
  index: 5,
  opacity: 0.85
}, {
  index: 4,
  opacity: 0.9
}, {
  index: 3,
  opacity: 0.95
}, {
  index: 2,
  opacity: 0.97
}, {
  index: 1,
  opacity: 0.98
}];
function Ht(e) {
  var t = e.r, r = e.g, n = e.b, o = qe(t, r, n);
  return {
    h: o.h * 360,
    s: o.s,
    v: o.v
  };
}
function ge(e) {
  var t = e.r, r = e.g, n = e.b;
  return "#".concat(Ye(t, r, n, !1));
}
function Zn(e, t, r) {
  var n = r / 100, o = {
    r: (t.r - e.r) * n + e.r,
    g: (t.g - e.g) * n + e.g,
    b: (t.b - e.b) * n + e.b
  };
  return o;
}
function Et(e, t, r) {
  var n;
  return Math.round(e.h) >= 60 && Math.round(e.h) <= 240 ? n = r ? Math.round(e.h) - he * t : Math.round(e.h) + he * t : n = r ? Math.round(e.h) + he * t : Math.round(e.h) - he * t, n < 0 ? n += 360 : n >= 360 && (n -= 360), n;
}
function zt(e, t, r) {
  if (e.h === 0 && e.s === 0)
    return e.s;
  var n;
  return r ? n = e.s - kt * t : t === ar ? n = e.s + kt : n = e.s + qn * t, n > 1 && (n = 1), r && t === or && n > 0.1 && (n = 0.1), n < 0.06 && (n = 0.06), Number(n.toFixed(2));
}
function $t(e, t, r) {
  var n;
  return r ? n = e.v + Yn * t : n = e.v - Qn * t, n > 1 && (n = 1), Number(n.toFixed(2));
}
function Z(e) {
  for (var t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, r = [], n = K(e), o = or; o > 0; o -= 1) {
    var a = Ht(n), i = ge(K({
      h: Et(a, o, !0),
      s: zt(a, o, !0),
      v: $t(a, o, !0)
    }));
    r.push(i);
  }
  r.push(ge(n));
  for (var s = 1; s <= ar; s += 1) {
    var c = Ht(n), h = ge(K({
      h: Et(c, s),
      s: zt(c, s),
      v: $t(c, s)
    }));
    r.push(h);
  }
  return t.theme === "dark" ? Jn.map(function(f) {
    var l = f.index, u = f.opacity, p = ge(Zn(K(t.backgroundColor || "#141414"), K(r[l]), u * 100));
    return p;
  }) : r;
}
var De = {
  red: "#F5222D",
  volcano: "#FA541C",
  orange: "#FA8C16",
  gold: "#FAAD14",
  yellow: "#FADB14",
  lime: "#A0D911",
  green: "#52C41A",
  cyan: "#13C2C2",
  blue: "#1890FF",
  geekblue: "#2F54EB",
  purple: "#722ED1",
  magenta: "#EB2F96",
  grey: "#666666"
}, Ie = {}, Oe = {};
Object.keys(De).forEach(function(e) {
  Ie[e] = Z(De[e]), Ie[e].primary = Ie[e][5], Oe[e] = Z(De[e], {
    theme: "dark",
    backgroundColor: "#141414"
  }), Oe[e].primary = Oe[e][5];
});
const eo = (e) => {
  const {
    controlHeight: t
  } = e;
  return {
    controlHeightSM: t * 0.75,
    controlHeightXS: t * 0.5,
    controlHeightLG: t * 1.25
  };
}, ir = eo;
function to(e) {
  const {
    sizeUnit: t,
    sizeStep: r
  } = e;
  return {
    sizeXXL: t * (r + 8),
    sizeXL: t * (r + 4),
    sizeLG: t * (r + 2),
    sizeMD: t * (r + 1),
    sizeMS: t * r,
    size: t * r,
    sizeSM: t * (r - 1),
    sizeXS: t * (r - 2),
    sizeXXS: t * (r - 3)
    // 4
  };
}
const lt = {
  blue: "#1677ff",
  purple: "#722ED1",
  cyan: "#13C2C2",
  green: "#52C41A",
  magenta: "#EB2F96",
  pink: "#eb2f96",
  red: "#F5222D",
  orange: "#FA8C16",
  yellow: "#FADB14",
  volcano: "#FA541C",
  geekblue: "#2F54EB",
  gold: "#FAAD14",
  lime: "#A0D911"
}, ut = v(v({}, lt), {
  // Color
  colorPrimary: "#1677ff",
  colorSuccess: "#52c41a",
  colorWarning: "#faad14",
  colorError: "#ff4d4f",
  colorInfo: "#1677ff",
  colorTextBase: "",
  colorBgBase: "",
  // Font
  fontFamily: `-apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, 'Helvetica Neue', Arial,
'Noto Sans', sans-serif, 'Apple Color Emoji', 'Segoe UI Emoji', 'Segoe UI Symbol',
'Noto Color Emoji'`,
  fontSize: 14,
  // Line
  lineWidth: 1,
  lineType: "solid",
  // Motion
  motionUnit: 0.1,
  motionBase: 0,
  motionEaseOutCirc: "cubic-bezier(0.08, 0.82, 0.17, 1)",
  motionEaseInOutCirc: "cubic-bezier(0.78, 0.14, 0.15, 0.86)",
  motionEaseOut: "cubic-bezier(0.215, 0.61, 0.355, 1)",
  motionEaseInOut: "cubic-bezier(0.645, 0.045, 0.355, 1)",
  motionEaseOutBack: "cubic-bezier(0.12, 0.4, 0.29, 1.46)",
  motionEaseInBack: "cubic-bezier(0.71, -0.46, 0.88, 0.6)",
  motionEaseInQuint: "cubic-bezier(0.755, 0.05, 0.855, 0.06)",
  motionEaseOutQuint: "cubic-bezier(0.23, 1, 0.32, 1)",
  // Radius
  borderRadius: 6,
  // Size
  sizeUnit: 4,
  sizeStep: 4,
  sizePopupArrow: 16,
  // Control Base
  controlHeight: 32,
  // zIndex
  zIndexBase: 0,
  zIndexPopupBase: 1e3,
  // Image
  opacityImage: 1,
  // Wireframe
  wireframe: !1
});
function sr(e, t) {
  let {
    generateColorPalettes: r,
    generateNeutralColorPalettes: n
  } = t;
  const {
    colorSuccess: o,
    colorWarning: a,
    colorError: i,
    colorInfo: s,
    colorPrimary: c,
    colorBgBase: h,
    colorTextBase: f
  } = e, l = r(c), u = r(o), p = r(a), b = r(i), y = r(s), C = n(h, f);
  return v(v({}, C), {
    colorPrimaryBg: l[1],
    colorPrimaryBgHover: l[2],
    colorPrimaryBorder: l[3],
    colorPrimaryBorderHover: l[4],
    colorPrimaryHover: l[5],
    colorPrimary: l[6],
    colorPrimaryActive: l[7],
    colorPrimaryTextHover: l[8],
    colorPrimaryText: l[9],
    colorPrimaryTextActive: l[10],
    colorSuccessBg: u[1],
    colorSuccessBgHover: u[2],
    colorSuccessBorder: u[3],
    colorSuccessBorderHover: u[4],
    colorSuccessHover: u[4],
    colorSuccess: u[6],
    colorSuccessActive: u[7],
    colorSuccessTextHover: u[8],
    colorSuccessText: u[9],
    colorSuccessTextActive: u[10],
    colorErrorBg: b[1],
    colorErrorBgHover: b[2],
    colorErrorBorder: b[3],
    colorErrorBorderHover: b[4],
    colorErrorHover: b[5],
    colorError: b[6],
    colorErrorActive: b[7],
    colorErrorTextHover: b[8],
    colorErrorText: b[9],
    colorErrorTextActive: b[10],
    colorWarningBg: p[1],
    colorWarningBgHover: p[2],
    colorWarningBorder: p[3],
    colorWarningBorderHover: p[4],
    colorWarningHover: p[4],
    colorWarning: p[6],
    colorWarningActive: p[7],
    colorWarningTextHover: p[8],
    colorWarningText: p[9],
    colorWarningTextActive: p[10],
    colorInfoBg: y[1],
    colorInfoBgHover: y[2],
    colorInfoBorder: y[3],
    colorInfoBorderHover: y[4],
    colorInfoHover: y[4],
    colorInfo: y[6],
    colorInfoActive: y[7],
    colorInfoTextHover: y[8],
    colorInfoText: y[9],
    colorInfoTextActive: y[10],
    colorBgMask: new R("#000").setAlpha(0.45).toRgbString(),
    colorWhite: "#fff"
  });
}
const ro = (e) => {
  let t = e, r = e, n = e, o = e;
  return e < 6 && e >= 5 ? t = e + 1 : e < 16 && e >= 6 ? t = e + 2 : e >= 16 && (t = 16), e < 7 && e >= 5 ? r = 4 : e < 8 && e >= 7 ? r = 5 : e < 14 && e >= 8 ? r = 6 : e < 16 && e >= 14 ? r = 7 : e >= 16 && (r = 8), e < 6 && e >= 2 ? n = 1 : e >= 6 && (n = 2), e > 4 && e < 8 ? o = 4 : e >= 8 && (o = 6), {
    borderRadius: e > 16 ? 16 : e,
    borderRadiusXS: n,
    borderRadiusSM: r,
    borderRadiusLG: t,
    borderRadiusOuter: o
  };
}, no = ro;
function oo(e) {
  const {
    motionUnit: t,
    motionBase: r,
    borderRadius: n,
    lineWidth: o
  } = e;
  return v({
    // motion
    motionDurationFast: `${(r + t).toFixed(1)}s`,
    motionDurationMid: `${(r + t * 2).toFixed(1)}s`,
    motionDurationSlow: `${(r + t * 3).toFixed(1)}s`,
    // line
    lineWidthBold: o + 1
  }, no(n));
}
const F = (e, t) => new R(e).setAlpha(t).toRgbString(), re = (e, t) => new R(e).darken(t).toHexString(), ao = (e) => {
  const t = Z(e);
  return {
    1: t[0],
    2: t[1],
    3: t[2],
    4: t[3],
    5: t[4],
    6: t[5],
    7: t[6],
    8: t[4],
    9: t[5],
    10: t[6]
    // 8: colors[7],
    // 9: colors[8],
    // 10: colors[9],
  };
}, io = (e, t) => {
  const r = e || "#fff", n = t || "#000";
  return {
    colorBgBase: r,
    colorTextBase: n,
    colorText: F(n, 0.88),
    colorTextSecondary: F(n, 0.65),
    colorTextTertiary: F(n, 0.45),
    colorTextQuaternary: F(n, 0.25),
    colorFill: F(n, 0.15),
    colorFillSecondary: F(n, 0.06),
    colorFillTertiary: F(n, 0.04),
    colorFillQuaternary: F(n, 0.02),
    colorBgLayout: re(r, 4),
    colorBgContainer: re(r, 0),
    colorBgElevated: re(r, 0),
    colorBgSpotlight: F(n, 0.85),
    colorBorder: re(r, 15),
    colorBorderSecondary: re(r, 6)
  };
};
function so(e) {
  const t = new Array(10).fill(null).map((r, n) => {
    const o = n - 1, a = e * Math.pow(2.71828, o / 5), i = n > 1 ? Math.floor(a) : Math.ceil(a);
    return Math.floor(i / 2) * 2;
  });
  return t[1] = e, t.map((r) => {
    const n = r + 8;
    return {
      size: r,
      lineHeight: n / r
    };
  });
}
const co = (e) => {
  const t = so(e), r = t.map((o) => o.size), n = t.map((o) => o.lineHeight);
  return {
    fontSizeSM: r[0],
    fontSize: r[1],
    fontSizeLG: r[2],
    fontSizeXL: r[3],
    fontSizeHeading1: r[6],
    fontSizeHeading2: r[5],
    fontSizeHeading3: r[4],
    fontSizeHeading4: r[3],
    fontSizeHeading5: r[2],
    lineHeight: n[1],
    lineHeightLG: n[2],
    lineHeightSM: n[0],
    lineHeightHeading1: n[6],
    lineHeightHeading2: n[5],
    lineHeightHeading3: n[4],
    lineHeightHeading4: n[3],
    lineHeightHeading5: n[2]
  };
}, cr = co;
function ke(e) {
  const t = Object.keys(lt).map((r) => {
    const n = Z(e[r]);
    return new Array(10).fill(1).reduce((o, a, i) => (o[`${r}-${i + 1}`] = n[i], o), {});
  }).reduce((r, n) => (r = v(v({}, r), n), r), {});
  return v(v(v(v(v(v(v({}, e), t), sr(e, {
    generateColorPalettes: ao,
    generateNeutralColorPalettes: io
  })), cr(e.fontSize)), to(e)), ir(e)), oo(e));
}
function Fe(e) {
  return e >= 0 && e <= 255;
}
function ve(e, t) {
  const {
    r,
    g: n,
    b: o,
    a
  } = new R(e).toRgb();
  if (a < 1)
    return e;
  const {
    r: i,
    g: s,
    b: c
  } = new R(t).toRgb();
  for (let h = 0.01; h <= 1; h += 0.01) {
    const f = Math.round((r - i * (1 - h)) / h), l = Math.round((n - s * (1 - h)) / h), u = Math.round((o - c * (1 - h)) / h);
    if (Fe(f) && Fe(l) && Fe(u))
      return new R({
        r: f,
        g: l,
        b: u,
        a: Math.round(h * 100) / 100
      }).toRgbString();
  }
  return new R({
    r,
    g: n,
    b: o,
    a: 1
  }).toRgbString();
}
var lo = globalThis && globalThis.__rest || function(e, t) {
  var r = {};
  for (var n in e)
    Object.prototype.hasOwnProperty.call(e, n) && t.indexOf(n) < 0 && (r[n] = e[n]);
  if (e != null && typeof Object.getOwnPropertySymbols == "function")
    for (var o = 0, n = Object.getOwnPropertySymbols(e); o < n.length; o++)
      t.indexOf(n[o]) < 0 && Object.prototype.propertyIsEnumerable.call(e, n[o]) && (r[n[o]] = e[n[o]]);
  return r;
};
function uo(e) {
  const {
    override: t
  } = e, r = lo(e, ["override"]), n = v({}, t);
  Object.keys(ut).forEach((p) => {
    delete n[p];
  });
  const o = v(v({}, r), n), a = 480, i = 576, s = 768, c = 992, h = 1200, f = 1600, l = 2e3;
  return v(v(v({}, o), {
    colorLink: o.colorInfoText,
    colorLinkHover: o.colorInfoHover,
    colorLinkActive: o.colorInfoActive,
    // ============== Background ============== //
    colorFillContent: o.colorFillSecondary,
    colorFillContentHover: o.colorFill,
    colorFillAlter: o.colorFillQuaternary,
    colorBgContainerDisabled: o.colorFillTertiary,
    // ============== Split ============== //
    colorBorderBg: o.colorBgContainer,
    colorSplit: ve(o.colorBorderSecondary, o.colorBgContainer),
    // ============== Text ============== //
    colorTextPlaceholder: o.colorTextQuaternary,
    colorTextDisabled: o.colorTextQuaternary,
    colorTextHeading: o.colorText,
    colorTextLabel: o.colorTextSecondary,
    colorTextDescription: o.colorTextTertiary,
    colorTextLightSolid: o.colorWhite,
    colorHighlight: o.colorError,
    colorBgTextHover: o.colorFillSecondary,
    colorBgTextActive: o.colorFill,
    colorIcon: o.colorTextTertiary,
    colorIconHover: o.colorText,
    colorErrorOutline: ve(o.colorErrorBg, o.colorBgContainer),
    colorWarningOutline: ve(o.colorWarningBg, o.colorBgContainer),
    // Font
    fontSizeIcon: o.fontSizeSM,
    // Control
    lineWidth: o.lineWidth,
    controlOutlineWidth: o.lineWidth * 2,
    // Checkbox size and expand icon size
    controlInteractiveSize: o.controlHeight / 2,
    controlItemBgHover: o.colorFillTertiary,
    controlItemBgActive: o.colorPrimaryBg,
    controlItemBgActiveHover: o.colorPrimaryBgHover,
    controlItemBgActiveDisabled: o.colorFill,
    controlTmpOutline: o.colorFillQuaternary,
    controlOutline: ve(o.colorPrimaryBg, o.colorBgContainer),
    lineType: o.lineType,
    borderRadius: o.borderRadius,
    borderRadiusXS: o.borderRadiusXS,
    borderRadiusSM: o.borderRadiusSM,
    borderRadiusLG: o.borderRadiusLG,
    fontWeightStrong: 600,
    opacityLoading: 0.65,
    linkDecoration: "none",
    linkHoverDecoration: "none",
    linkFocusDecoration: "none",
    controlPaddingHorizontal: 12,
    controlPaddingHorizontalSM: 8,
    paddingXXS: o.sizeXXS,
    paddingXS: o.sizeXS,
    paddingSM: o.sizeSM,
    padding: o.size,
    paddingMD: o.sizeMD,
    paddingLG: o.sizeLG,
    paddingXL: o.sizeXL,
    paddingContentHorizontalLG: o.sizeLG,
    paddingContentVerticalLG: o.sizeMS,
    paddingContentHorizontal: o.sizeMS,
    paddingContentVertical: o.sizeSM,
    paddingContentHorizontalSM: o.size,
    paddingContentVerticalSM: o.sizeXS,
    marginXXS: o.sizeXXS,
    marginXS: o.sizeXS,
    marginSM: o.sizeSM,
    margin: o.size,
    marginMD: o.sizeMD,
    marginLG: o.sizeLG,
    marginXL: o.sizeXL,
    marginXXL: o.sizeXXL,
    boxShadow: `
      0 1px 2px 0 rgba(0, 0, 0, 0.03),
      0 1px 6px -1px rgba(0, 0, 0, 0.02),
      0 2px 4px 0 rgba(0, 0, 0, 0.02)
    `,
    boxShadowSecondary: `
      0 6px 16px 0 rgba(0, 0, 0, 0.08),
      0 3px 6px -4px rgba(0, 0, 0, 0.12),
      0 9px 28px 8px rgba(0, 0, 0, 0.05)
    `,
    boxShadowTertiary: `
      0 1px 2px 0 rgba(0, 0, 0, 0.03),
      0 1px 6px -1px rgba(0, 0, 0, 0.02),
      0 2px 4px 0 rgba(0, 0, 0, 0.02)
    `,
    screenXS: a,
    screenXSMin: a,
    screenXSMax: i - 1,
    screenSM: i,
    screenSMMin: i,
    screenSMMax: s - 1,
    screenMD: s,
    screenMDMin: s,
    screenMDMax: c - 1,
    screenLG: c,
    screenLGMin: c,
    screenLGMax: h - 1,
    screenXL: h,
    screenXLMin: h,
    screenXLMax: f - 1,
    screenXXL: f,
    screenXXLMin: f,
    screenXXLMax: l - 1,
    screenXXXL: l,
    screenXXXLMin: l,
    // FIXME: component box-shadow, should be removed
    boxShadowPopoverArrow: "3px 3px 7px rgba(0, 0, 0, 0.1)",
    boxShadowCard: `
      0 1px 2px -2px ${new R("rgba(0, 0, 0, 0.16)").toRgbString()},
      0 3px 6px 0 ${new R("rgba(0, 0, 0, 0.12)").toRgbString()},
      0 5px 12px 4px ${new R("rgba(0, 0, 0, 0.09)").toRgbString()}
    `,
    boxShadowDrawerRight: `
      -6px 0 16px 0 rgba(0, 0, 0, 0.08),
      -3px 0 6px -4px rgba(0, 0, 0, 0.12),
      -9px 0 28px 8px rgba(0, 0, 0, 0.05)
    `,
    boxShadowDrawerLeft: `
      6px 0 16px 0 rgba(0, 0, 0, 0.08),
      3px 0 6px -4px rgba(0, 0, 0, 0.12),
      9px 0 28px 8px rgba(0, 0, 0, 0.05)
    `,
    boxShadowDrawerUp: `
      0 6px 16px 0 rgba(0, 0, 0, 0.08),
      0 3px 6px -4px rgba(0, 0, 0, 0.12),
      0 9px 28px 8px rgba(0, 0, 0, 0.05)
    `,
    boxShadowDrawerDown: `
      0 -6px 16px 0 rgba(0, 0, 0, 0.08),
      0 -3px 6px -4px rgba(0, 0, 0, 0.12),
      0 -9px 28px 8px rgba(0, 0, 0, 0.05)
    `,
    boxShadowTabsOverflowLeft: "inset 10px 0 8px -8px rgba(0, 0, 0, 0.08)",
    boxShadowTabsOverflowRight: "inset -10px 0 8px -8px rgba(0, 0, 0, 0.08)",
    boxShadowTabsOverflowTop: "inset 0 10px 8px -8px rgba(0, 0, 0, 0.08)",
    boxShadowTabsOverflowBottom: "inset 0 -10px 8px -8px rgba(0, 0, 0, 0.08)"
  }), n);
}
function fo(e) {
  if (!Bt(e))
    return ft(e);
  const t = new Proxy({}, {
    get(r, n, o) {
      return Reflect.get(e.value, n, o);
    },
    set(r, n, o) {
      return e.value[n] = o, !0;
    },
    deleteProperty(r, n) {
      return Reflect.deleteProperty(e.value, n);
    },
    has(r, n) {
      return Reflect.has(e.value, n);
    },
    ownKeys() {
      return Object.keys(e.value);
    },
    getOwnPropertyDescriptor() {
      return {
        enumerable: !0,
        configurable: !0
      };
    }
  });
  return ft(t);
}
const ho = Dn(ke), Je = {
  token: ut,
  hashed: !0
}, lr = Symbol("DesignTokenContext"), ur = $(), go = (e) => {
  tt(lr, e), Rt(() => {
    ur.value = e;
  });
};
se({
  props: {
    value: It()
  },
  setup(e, t) {
    let {
      slots: r
    } = t;
    return go(fo(k(() => e.value))), () => {
      var n;
      return (n = r.default) === null || n === void 0 ? void 0 : n.call(r);
    };
  }
});
function vo() {
  const e = rt(lr, ur.value || Je), t = k(() => `${In}-${e.hashed || ""}`), r = k(() => e.theme || ho), n = rn(r, k(() => [ut, e.token]), k(() => ({
    salt: t.value,
    override: v({
      override: e.token
    }, e.components),
    formatToken: uo
  })));
  return [r, k(() => n.value[0]), k(() => e.hashed ? n.value[1] : "")];
}
const _ = (e, t) => new R(e).setAlpha(t).toRgbString(), U = (e, t) => new R(e).lighten(t).toHexString(), po = (e) => {
  const t = Z(e, {
    theme: "dark"
  });
  return {
    1: t[0],
    2: t[1],
    3: t[2],
    4: t[3],
    5: t[6],
    6: t[5],
    7: t[4],
    8: t[6],
    9: t[5],
    10: t[4]
    // 8: colors[9],
    // 9: colors[8],
    // 10: colors[7],
  };
}, mo = (e, t) => {
  const r = e || "#000", n = t || "#fff";
  return {
    colorBgBase: r,
    colorTextBase: n,
    colorText: _(n, 0.85),
    colorTextSecondary: _(n, 0.65),
    colorTextTertiary: _(n, 0.45),
    colorTextQuaternary: _(n, 0.25),
    colorFill: _(n, 0.18),
    colorFillSecondary: _(n, 0.12),
    colorFillTertiary: _(n, 0.08),
    colorFillQuaternary: _(n, 0.04),
    colorBgElevated: U(r, 12),
    colorBgContainer: U(r, 8),
    colorBgLayout: U(r, 0),
    colorBgSpotlight: U(r, 26),
    colorBorder: U(r, 26),
    colorBorderSecondary: U(r, 19)
  };
}, bo = (e, t) => {
  const r = Object.keys(lt).map((o) => {
    const a = Z(e[o], {
      theme: "dark"
    });
    return new Array(10).fill(1).reduce((i, s, c) => (i[`${o}-${c + 1}`] = a[c], i), {});
  }).reduce((o, a) => (o = v(v({}, o), a), o), {}), n = t ?? ke(e);
  return v(v(v({}, n), r), sr(e, {
    generateColorPalettes: po,
    generateNeutralColorPalettes: mo
  }));
}, yo = bo;
function So(e) {
  const {
    sizeUnit: t,
    sizeStep: r
  } = e, n = r - 2;
  return {
    sizeXXL: t * (n + 10),
    sizeXL: t * (n + 6),
    sizeLG: t * (n + 2),
    sizeMD: t * (n + 2),
    sizeMS: t * (n + 1),
    size: t * n,
    sizeSM: t * n,
    sizeXS: t * (n - 1),
    sizeXXS: t * (n - 1)
  };
}
const xo = (e, t) => {
  const r = t ?? ke(e), n = r.fontSizeSM, o = r.controlHeight - 4;
  return v(v(v(v(v({}, r), So(t ?? e)), cr(n)), {
    // controlHeight
    controlHeight: o
  }), ir(v(v({}, r), {
    controlHeight: o
  })));
}, wo = xo;
function Co() {
  const [e, t, r] = vo();
  return {
    theme: e,
    token: t,
    hashId: r
  };
}
const To = {
  /** @private Test Usage. Do not use in production. */
  defaultConfig: Je,
  /** Default seedToken */
  defaultSeed: Je.token,
  useToken: Co,
  defaultAlgorithm: ke,
  darkAlgorithm: yo,
  compactAlgorithm: wo
}, Mo = (e, t) => {
  const { fontFamily: r, fontSize: n } = e, o = `[class^="${t}"], [class*=" ${t}"]`;
  return {
    [o]: {
      fontFamily: r,
      fontSize: n,
      boxSizing: "border-box",
      "&::before, &::after": {
        boxSizing: "border-box"
      },
      [o]: {
        boxSizing: "border-box",
        "&::before, &::after": {
          boxSizing: "border-box"
        }
      }
    }
  };
}, Ao = (e) => ({
  a: {
    color: e.colorLink,
    textDecoration: e.linkDecoration,
    backgroundColor: "transparent",
    outline: "none",
    cursor: "pointer",
    transition: `color ${e.motionDurationSlow}`,
    "-webkit-text-decoration-skip": "objects",
    "&:hover": {
      color: e.colorLinkHover
    },
    "&:active": {
      color: e.colorLinkActive
    },
    [`&:active,
  &:hover`]: {
      textDecoration: e.linkHoverDecoration,
      outline: 0
    },
    // https://github.com/ant-design/ant-design/issues/22503
    "&:focus": {
      textDecoration: e.linkFocusDecoration,
      outline: 0
    },
    "&[disabled]": {
      color: e.colorTextDisabled,
      cursor: "not-allowed"
    }
  }
}), fr = (
  // @ts-ignore
  process.env.NODE_ENV !== "production" || typeof CSSINJS_STATISTIC < "u"
);
let Ze = !0;
function dr(...e) {
  if (!fr)
    return Object.assign({}, ...e);
  Ze = !1;
  const t = {};
  return e.forEach((r) => {
    Object.keys(r).forEach((n) => {
      Object.defineProperty(t, n, {
        configurable: !0,
        enumerable: !0,
        get: () => r[n]
      });
    });
  }), Ze = !0, t;
}
function ko() {
}
function Ho(e) {
  let t, r = e, n = ko;
  return fr && (t = /* @__PURE__ */ new Set(), r = new Proxy(e, {
    get(o, a) {
      return Ze && t.add(a), o[a];
    }
  }), n = (o, a) => {
    Array.from(t);
  }), { token: r, keys: t, flush: n };
}
class hr {
  constructor(t, r) {
    this._keyframe = !0, this.name = t, this.style = r;
  }
  getName(t = "") {
    return t ? `${t}-${this.name}` : this.name;
  }
}
const Eo = (e, t = {}) => e ? {
  name: e,
  appear: !0,
  // type: 'animation',
  // appearFromClass: `${transitionName}-appear ${transitionName}-appear-prepare`,
  // appearActiveClass: `antdv-base-transtion`,
  // appearToClass: `${transitionName}-appear ${transitionName}-appear-active`,
  enterFromClass: `${e}-enter ${e}-enter-prepare ${e}-enter-start`,
  enterActiveClass: `${e}-enter ${e}-enter-prepare`,
  enterToClass: `${e}-enter ${e}-enter-active`,
  leaveFromClass: ` ${e}-leave`,
  leaveActiveClass: `${e}-leave ${e}-leave-active`,
  leaveToClass: `${e}-leave ${e}-leave-active`,
  ...t
} : { css: !1, ...t }, { useToken: zo } = To;
function $o(e, t) {
  return (r) => {
    const n = pe({}), o = k(() => Bt(r) ? r == null ? void 0 : r.value : r || n), { token: a, hashId: i, theme: s } = zo(), c = k(() => pe({})), h = k(() => ({
      theme: s.value,
      token: a.value,
      hashId: i.value,
      path: ["Shared", c.value]
    }));
    Ct(h, () => [
      {
        "&": Ao(a.value)
      }
    ]);
    const f = k(() => ({
      theme: s.value,
      token: a.value,
      hashId: i.value,
      path: [e, o.value]
    }));
    return [
      Ct(f, () => {
        const { token: l, flush: u } = Ho(a.value), p = `.${o.value}`, b = dr(l, {
          antCls: ".ant",
          componentCls: p,
          proComponentsCls: pe({
            isPor: !0
          })
        }), y = t(b, {
          hashId: i.value,
          prefixCls: o.value
        });
        return u(e, {}), [Mo(a.value, o.value), y];
      }),
      i
    ];
  };
}
const et = /* @__PURE__ */ se({
  props: Hr,
  setup(e) {
    const {
      hashId: t,
      wrapElement: r,
      scrollbarElement: n,
      className: o
    } = Ar(), a = $(), i = $(), s = $({}), c = $(!1);
    let h = !1, f = !1, l = xr ? document.onselectstart : null;
    const u = k(() => Er[e.vertical ? "vertical" : "horizontal"]), p = k(() => $r({
      size: e.size,
      move: e.move,
      bar: u.value
    })), b = k(() => (
      // offsetRatioX = original width of thumb / current width of thumb / ratioX
      // offsetRatioY = original height of thumb / current height of thumb / ratioY
      // instance height = wrap height - GAP
      a.value[u.value.offset] ** 2 / r.value[u.value.scrollSize] / ((e == null ? void 0 : e.ratio) || 0) / i.value[u.value.offset]
    )), y = (d) => {
      var g;
      if (d.stopPropagation(), d.ctrlKey || [1, 2].includes(d.button))
        return;
      (g = window.getSelection()) == null || g.removeAllRanges(), x(d);
      const T = d.currentTarget;
      T && (s.value[u.value.axis] = T[u.value.offset] - (d[u.value.client] - T.getBoundingClientRect()[u.value.direction]));
    }, C = (d) => {
      if (!i.value || !a.value || !r.value)
        return;
      const T = Math.abs(d.target.getBoundingClientRect()[u.value.direction] - d[u.value.client]), g = i.value[u.value.offset] / 2, z = (T - g) * 100 * b.value / a.value[u.value.offset];
      r.value[u.value.scroll] = z * r.value[u.value.scrollSize] / 100;
    }, x = (d) => {
      d.stopImmediatePropagation(), h = !0, document.addEventListener("mousemove", m), document.addEventListener("mouseup", w), l = document.onselectstart, document.onselectstart = () => !1;
    }, m = (d) => {
      if (!a.value || !i.value || h === !1)
        return;
      const T = s.value[u.value.axis];
      if (!T)
        return;
      const g = (a.value.getBoundingClientRect()[u.value.direction] - d[u.value.client]) * -1, z = i.value[u.value.offset] - T, te = (g - z) * 100 * b.value / a.value[u.value.offset];
      r.value[u.value.scroll] = te * r.value[u.value.scrollSize] / 100;
    }, w = () => {
      h = !1, s.value[u.value.axis] = 0, document.removeEventListener("mousemove", m), document.removeEventListener("mouseup", w), A(), f && (c.value = !1);
    }, M = () => {
      f = !1, c.value = !!e.size;
    }, S = () => {
      f = !0, c.value = h;
    };
    Nt(() => {
      A(), document.removeEventListener("mouseup", w);
    });
    const A = () => {
      document.onselectstart !== l && (document.onselectstart = l);
    };
    return q(() => n.value, (d) => {
      xe(d, "mousemove", M), xe(d, "mouseleave", S);
    }), () => {
      const d = Eo(`${o}-fade`);
      return I(pr, d, {
        default: () => [mr(I("div", {
          ref: a,
          class: [`${o}-bar`, "is-" + u.value.key, t.value],
          onMousedown: C
        }, [I("div", {
          ref: i,
          class: `${o}-thumb ${t.value}`,
          style: p.value,
          onMousedown: y
        }, null)]), [[br, e.always || c.value]])]
      });
    };
  }
});
et.inheritAttrs = !1;
const Po = /* @__PURE__ */ se({
  inheritAttrs: !1,
  props: kr,
  setup(e, {
    expose: t
  }) {
    const r = $(0), n = $(0), o = 4;
    return t({
      handleScroll: (i) => {
        if (i) {
          const s = i.offsetHeight - o, c = i.offsetWidth - o;
          n.value = i.scrollTop * 100 / s * e.ratioY, r.value = i.scrollLeft * 100 / c * e.ratioX;
        }
      }
    }), () => I(yr, null, [I(et, {
      move: r.value,
      ratio: e.ratioX,
      size: e.width,
      always: e.always
    }, null), I(et, {
      move: n.value,
      ratio: e.ratioY,
      size: e.height,
      vertical: !0,
      always: e.always
    }, null)]);
  }
}), Ro = new hr("fadeIn", {
  "0%": {
    opacity: 0
  },
  "100%": {
    opacity: 1
  }
}), No = new hr("fadeOut", {
  "0%": {
    opacity: 1
  },
  "100%": {
    opacity: 0
  }
}), Bo = (e) => ({
  [`${e.componentCls}`]: {
    position: "relative",
    height: "100%",
    overflow: "hidden",
    ["&-wrap"]: {
      height: "100%",
      overflow: "auto",
      ["&-hidden-default"]: {
        scrollbarWidth: "none",
        ["&::-webkit-scrollbar"]: {
          display: "none"
        }
      }
    },
    ["&-bar"]: {
      position: "absolute",
      right: 2,
      bottom: 2,
      zIndex: 1,
      borderRadius: 4,
      ["&.is-vertical"]: {
        top: 2,
        width: 6,
        ["& > div"]: {
          width: "100%"
        }
      },
      ["&.is-horizontal"]: {
        left: 2,
        height: 6,
        ["& > div"]: {
          height: "100%"
        }
      }
    },
    ["&-thumb"]: {
      position: "relative",
      display: "block",
      width: 0,
      height: 0,
      cursor: "pointer",
      backgroundColor: "rgba(0, 0, 0, 0.25)",
      borderRadius: e.borderRadius,
      transition: ".3s background-color",
      ["&:hover"]: {
        backgroundColor: "rgba(0, 0, 0, 0.4)"
      }
    },
    ["&-fade-appear, &-fade-enter"]: {
      animationName: Ro,
      animationDuration: ".34s",
      animationTimingFunction: "ease-out"
    },
    ["&-fade-leave"]: {
      animationName: No,
      animationDuration: ".34s",
      animationTimingFunction: "ease-out"
    }
  }
}), Do = $o("ScrollBar", (e) => {
  const t = dr(e);
  return [Bo(t)];
}), Io = /* @__PURE__ */ se({
  name: "GScrollbars",
  props: wr,
  emits: Cr,
  setup(e, {
    emit: t,
    slots: r,
    expose: n
  }) {
    const o = pe({
      suffixCls: "scrollbar"
    }), [a, i] = Do(o);
    let s, c;
    const h = $(), f = $(), l = $(), u = $("0"), p = $("0"), b = $(), y = $(1), C = $(1), x = "GScrollbars", m = 4, w = k(() => {
      const g = {};
      return e.height && (g.height = gt(e.height)), e.maxHeight && (g.maxHeight = gt(e.maxHeight)), [e.wrapStyle, g];
    }), M = () => {
      var g;
      f.value && ((g = b.value) == null || g.handleScroll(f.value), t("scroll", {
        scrollTop: f.value.scrollTop,
        scrollLeft: f.value.scrollLeft
      }));
    };
    function S(g, z) {
      gr(g) ? f.value.scrollTo(g) : j(g) && j(z) && f.value.scrollTo(g, z);
    }
    const A = (g) => {
      if (!j(g)) {
        console.warn(x, "value 必须为数字");
        return;
      }
      f.value.scrollTop = g;
    }, d = (g) => {
      if (!j(g)) {
        console.warn(x, "value 必须为数字");
        return;
      }
      f.value.scrollLeft = g;
    }, T = () => {
      if (!f.value)
        return;
      const g = f.value.offsetHeight - m, z = f.value.offsetWidth - m, te = g ** 2 / f.value.scrollHeight, He = z ** 2 / f.value.scrollWidth, ce = Math.max(te, e.minSize), le = Math.max(He, e.minSize);
      y.value = te / (g - te) / (ce / (g - ce)), C.value = He / (z - He) / (le / (z - le)), p.value = ce + m < g ? `${ce}px` : "", u.value = le + m < z ? `${le}px` : "";
    };
    return q(() => e.noresize, (g) => {
      g ? (s == null || s(), c == null || c()) : ({
        stop: s
      } = ht(l, T), c = xe("resize", T));
    }, {
      immediate: !0
    }), q(() => e.noresize, (g) => {
      g ? (s == null || s(), c == null || c()) : ({
        stop: s
      } = ht(l, T), c = xe("resize", T));
    }, {
      immediate: !0
    }), q(() => [e.maxHeight, e.height], () => {
      e.native || dt(() => {
        var g;
        T(), f.value && ((g = b.value) == null || g.handleScroll(f.value));
      });
    }), Mr({
      hashId: i,
      className: o,
      wrapElement: f,
      scrollbarElement: h
    }), Sr(() => {
      e.native || dt(() => T());
    }), n({
      /** @description scrollbar wrap ref */
      wrapRef: f,
      /** @description update scrollbar state manually */
      update: T,
      /** @description scrolls to a particular set of coordinates */
      scrollTo: S,
      /** @description set distance to scroll top */
      setScrollTop: A,
      /** @description set distance to scroll left */
      setScrollLeft: d,
      /** @description handle scroll event */
      handleScroll: M
    }), () => {
      const g = e.tag;
      return a(I("div", {
        ref: h,
        class: `${o} ${i.value}`
      }, [I("div", {
        ref: f,
        class: [i.value, e.wrapClass, `${o}-wrap`, e.native ? "" : `${o}-wrap-hidden-default`],
        style: w.value,
        onScroll: M
      }, [I(g, {
        ref: l,
        class: [`${o}-view`, e.viewClass, i.value],
        style: e.viewStyle
      }, {
        default: () => {
          var z;
          return [(z = r.default) == null ? void 0 : z.call(r)];
        }
      })]), !e.native && I(Po, {
        ref: b,
        height: p.value,
        width: u.value,
        always: e.always,
        ratioX: C.value,
        ratioY: y.value
      }, null)]));
    };
  }
});
Io.inheritAttrs = !1;
export {
  Io as GScrollbars,
  Io as default,
  wr as scrollbarProps
};
